name: Release the ESP-IDF Project

on:
  workflow_dispatch:
  push:
    branches:
      - main
    paths:
      - "ePaper-ESP-IDF/**"

jobs:
  release:
    strategy:
      matrix:
        idf_ver: [release-v5.2]
        idf_target: [esp32s3]

    runs-on: ubuntu-latest

    steps:
      - name: Checkout repo
        uses: actions/checkout@v4
        with:
          submodules: "recursive"

      - name: ESP-IDF build
        uses: espressif/esp-idf-ci-action@v1
        with:
          esp_idf_version: ${{ matrix.idf_ver }}
          target: ${{ matrix.idf_target }}
          path: ePaper-ESP-IDF

      - name: Upload Firmware
        uses: fjogeleit/http-request-action@v1
        with:
          url: "${{ secrets.UPLOAD_URL }}"
          method: "POST"
          files: '{ "file": "${{ github.workspace }}/ePaper-ESP-IDF/build/tide-display.bin" }'
          timeout: 30000
